/* sf21r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__21 = 21;

real sf21r_c(real *x, integer *ierr)
{
    /* Initialized data */

    static real d21t43 = 21.43f;
    static real sys001 = 3.141593f;
    static real sys059 = 3.4e38f;

    /* System generated locals */
    integer i__1;
    real ret_val;

    /* Builtin functions */
    double sin(doublereal), log(doublereal), exp(doublereal);

    /* Local variables */
    static integer i__, n;
    static real p;
    static doublereal q;
    static real r__, z__;
    extern /* Subroutine */ int utsf10_c(integer *, integer *);
    static doublereal x1;
    static real z1;

    *ierr = 0;
    p = 1.f;
    if (*x <= d21t43) {
        goto L1;
    }
    *ierr = 66;
    goto L14;
L1:
    if (*x < 8.f) {
        goto L2;
    }
    r__ = *x;
    goto L11;
L2:
    if (*x <= -8.f) {
        goto L9;
    }
    x1 = *x - 2.f;
    n = (integer) x1;
    if (x1 < 0. && x1 != (doublereal) n) {
        --n;
    }
    r__ = x1 - (real) n;
    if (n < 0) {
        goto L6;
    } else if (n == 0) {
        goto L5;
    } else {
        goto L3;
    }
L3:
    i__1 = n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        p *= *x - (real) i__;
/* L4: */
    }
L5:
    goto L8;
L6:
    if ((real) n < -1.f && r__ == 0.f) {
        goto L13;
    }
    n = -n;
    i__1 = n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        p *= r__ + (real) (2 - i__);
/* L7: */
    }
    p = 1.f / p;
L8:
    q = ((((r__ * 9.382134f + 54.12242f) * r__ + 321.75f) * r__ + 843.7441f) *
             r__ + 1949.143f) / ((((((r__ - 10.20571f) * r__ + 24.87734f) * 
            r__ + 93.88405f) * r__ - 489.3048f) * r__ + 19.67692f) * r__ + 
            1949.143f);
    goto L12;
L9:
    r__ = 1.f - *x;
    n = *x;
    if (n - *x == 0.f) {
        goto L13;
    }
    x1 = (real)sin((real)(sys001 * *x));
    p = sys001;
    if (x1 < 0.) {
        goto L10;
    } else if (x1 == 0) {
        goto L13;
    } else {
        goto L11;
    }
L10:
    p = -p;
    x1 = -x1;
L11:
    z__ = 1.f / r__;
    z1 = z__ * z__;
    q = z__ * ((z1 * -.00169576483584 + .07954570047) * z1 + .113632924908) / 
            (z1 + 1.36359509891) + .918938533205 + (r__ - .5f) *
            (real)log(r__) - r__;
    if (*x < 0.f) {
        q = -q - log(x1);
    }
    q = exp(q);
L12:
    ret_val = p * q;
    goto L15;
L13:
    *ierr = 65;
L14:
    utsf10_c(ierr, &c__21);
    ret_val = sys059;
L15:
    return ret_val;
} /* sf21r_c */
